(* Time-stamp: <modified the 18/06/2014 (at 08:30) by Erwan Jahier> *)


(* exported *) 
let rec (gen_assign : Data.t  -> string -> string -> string) =
  fun t vi vo -> 
    match t with
      | Alias(_,t) -> gen_assign t vi vo
      | Enum _  
      | Struct(_) (* should I rather use memcpy for struct? *)
      | Bool | Int | Real -> 
        Printf.sprintf "  %s = %s;\n" vi vo
      | Alpha(_) (* dead code ? *)
      | Array(_) -> 
        Printf.sprintf "  memcpy(%s, %s, sizeof(%s));\n" vi vo vo

      | Extern (id) -> 
        (* what should i do for extern types? Ask the user to provide the
           copy function I guess *)
        Printf.sprintf "  cpy_%s(%s, %s);\n" id vi vo 


let id2s = Soc2cIdent.id2s

let (step_name : Soc.key -> string -> string) =
  fun (soc_name,tl,_) sm -> 
    let l = List.map Soc2cIdent.type_to_short_string tl in
    let str = Printf.sprintf "%s_%s_%s" (id2s soc_name)  (String.concat "" l) sm in
    id2s str


(* exported *) 
let (gen_step_call : Soc.t -> Soc.t -> string list -> string list -> 
     string -> string -> string -> string) =
  fun soc called_soc vel_out vel_in ctx sname step_arg -> 
    let si_str =
      if vel_in = [] then "" (* occurs for pre *) else 
        let inputs = fst called_soc.profile in
        let l = try (
          List.map2 (fun (name, t) ve -> 
            gen_assign t (Printf.sprintf "%s.%s" ctx name) ve) 
            inputs vel_in
        ) with _ -> assert false (* XXX not all parameters are necessaryly used! *)
        in
        (String.concat "" l) 
    in
    let so_str =
      if vel_out = [] then "" (* occurs for pre *) else 
        let outputs = snd called_soc.profile in
        let l = try (
          List.map2
            (fun  (name,t)  ve -> 
              gen_assign t ve
                (Printf.sprintf "%s.%s" ctx name)) outputs vel_out
        ) with _ -> assert false
        in
        (String.concat "" l) ^"\n"
    in
    let str = Printf.sprintf "  %s(%s); \n" (step_name called_soc.key sname) step_arg in
    (si_str ^ str ^ so_str)

